#ifndef LEXER_H_
#define LEXER_H_

#include <string>

using namespace std;

class Lexer
{
public:
	Lexer();
	virtual ~Lexer();
	void consumeData(const string& data);
	void consumeEOF();
	int getNextToken();
	string tokText() { return m_match; }
	string::size_type tokLength() { return m_match.length(); }
	void reset();
protected:
	void initSemifinishBuffer();
	void destroySemifinishBuffer();
	virtual int executeAction(short rule);
	void more() { m_more = true; }
	void less(int n) { m_less = n; m_match.resize(m_match.length()-n); }
	void begin(short scond);
	short m_scond;
	short m_state;
	string m_buffer;
	string m_match;
	int m_spos;
	int m_cpos;
	int m_last_match_pos;
	short m_last_match_rule;
	bool m_last_match_quick;
	bool m_got_eof;
	bool m_more;
	int m_less;
	short m_nstates;
	short m_nnde_states;
	const short *m_cur_dtran;
	const unsigned int *m_cur_stateprop;
	int *m_semifinishes;
	static const short m_total_states[];
	static const short m_non_deadend_states[];
	static const short *m_dtran[];
	static const unsigned int *m_stateprop[];
	static const short m_stateinfo[];
};

#endif
