/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef NFACONCATENATION_H_
#define NFACONCATENATION_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <list>
#include <vector>
#include "nfa.h"

using namespace std;

class NFAConcatenation : public NFA
{
public:
	NFAConcatenation(const NFA &first);
	NFAConcatenation(const NFA &first, const NFA &second);
	void addComponent(const NFA& component);
	virtual int nStates() const { return m_nstates; }
	virtual list<NFAMove> getMovesFrom(int state) const;
	virtual int length() const { return m_length; }
	virtual NFA* clone() const { return new NFAConcatenation(*this); }
private:
	void addFirstComponent(const NFA& component);
	int m_nstates;
	vector<list<NFAMove> > m_moves;
	list<NFAMove> m_start_moves;
	int m_length;
};

#endif
