/*
    BFilter - a web proxy which removes banner ads
    Copyright (C) 2002  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef CONFLEXER_H_
#define CONFLEXER_H_

#include <string>
#include <map>
#include <cstdio>

using namespace std;

class ConfLexer
{
public:
	static void setInput(FILE *input);
	static int storeSymbol(const string& symbol);
	static string getSymbol(int id);
	static int getCurLine() { return m_lineno; }
	static void setCurLine(int line) { m_lineno = line; }
	static void reset();
private:
	typedef map<int, string> symtab_type;
	typedef map<string, int> reverse_symtab_type;
	static int m_lineno;
	static symtab_type m_symtab;
	static reverse_symtab_type m_reverse_symtab;
};

extern "C" {
	extern int yylex();
}

#endif
