/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "htmltaginfo.h"

HTMLTagInfo::taglist_type HTMLTagInfo::m_tags;
bool HTMLTagInfo::m_tags_loaded = false;
HTMLTagInfo::Info HTMLTagInfo::m_default_info;

const HTMLTagInfo::Info&
HTMLTagInfo::getInfoOn(const string& tagname)
{
	if (!m_tags_loaded) {
		loadTags();
		m_tags_loaded = true;
	}
	taglist_type::const_iterator fit = m_tags.find(tagname);
	if (fit != m_tags.end()) {
		return fit->second;
	} else {
		return m_default_info;
	}
}

void
HTMLTagInfo::loadTags()
{
	m_tags["a"] = Info(ETAG_REQUIRED);
	m_tags["iframe"] = Info(ETAG_REQUIRED);
	m_tags["script"] = Info(ETAG_REQUIRED);
	m_tags["img"] = Info(ETAG_FORBIDDEN);
	m_tags["object"] = Info(ETAG_REQUIRED);
	m_tags["param"] = Info(ETAG_FORBIDDEN);
}

