/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTMLTEXTNODE_H_
#define HTMLTEXTNODE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include "htmlnode.h"

using namespace std;

class HTMLTextNode : public HTMLNode
{
public:
	HTMLTextNode(const string& text) : m_text(text) {}
	virtual node_type_enum getType() const { return NODE_TEXT; }
	virtual string toString(bool xhtml, const set<const HTMLNode *> *noclose=0) const { return m_text; }
	virtual string contentsToString(bool xhtml, const set<const HTMLNode *> *noclose=0) const { return m_text; }
protected:
	virtual HTMLNode* clone() const { return new HTMLTextNode(*this); }
	virtual void appendChild(HTMLNode *node) {}
	virtual void removeChild(HTMLNode *node) {}
	virtual void removeAllChildren() {}
private:
	string m_text;
};

#endif

