/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTTPSTATEHEADERS_H_
#define HTTPSTATEHEADERS_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include "httpstate.h"
#include "httpheaderscollection.h"
#include "httprequestline.h"
#include "httpstatusline.h"

using namespace std;

class HttpStream;

class HttpStateHeaders : public HttpState
{
public:
	HttpStateHeaders(HttpStream& owner);
	virtual ~HttpStateHeaders();
	virtual void consumeDataChunk(string& pool);
	virtual void consumeEOF();
	virtual void cleanup();
	void setRequestLine(const HttpRequestLine& request_line);
	void setStatusLine(const HttpStatusLine& status_line);
private:
	bool feedLine(const string& line);
	void addHeader();
	void headersReceived();
	HttpStream& m_owner;
	HttpHeadersCollection m_headers;
	string m_cur_header;
	string m_queued_data;
	bool m_waiting_lws;
	HttpRequestLine *m_request_line;
	HttpStatusLine *m_status_line;
	
};

#endif
