/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef NAMEVALUEPAIR_H_
#define NAMEVALUEPAIR_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include "utils.h"

using namespace std;

class NameValuePair
{
public:
	NameValuePair(const string& name, const string& value)
	: m_name(name), m_lcname(strtolower(name)), m_value(value) {}
	virtual ~NameValuePair() {}
	const string& getName() const { return m_name; }
	const string& getLowercaseName() const { return m_lcname; }
	void setName(const string& name) { m_name = name; m_lcname = strtolower(name); }
	const string& getValue() const { return m_value; }
	void setValue(const string& value) { m_value = value; }
private:
	string m_name;
	string m_lcname;
	string m_value;
};

#endif

