/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef RESPONSEFILTERCHAIN_H_
#define RESPONSEFILTERCHAIN_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include <list>
#include "abstractresponsefilter.h"
#include "httpresponsemetadata.h"

using namespace std;

class ResponseFilterChain
{
public:
	ResponseFilterChain(const HttpResponseMetadata& metadata, AbstractResponseFilter *first_filter);
	~ResponseFilterChain();
	void addFilter(AbstractResponseFilter *filter);
	bool isMetadataReady() const;
	const HttpResponseMetadata& getMetadata() const { return m_metadata; }
	void consumeDataChunk(const string& data);
	void consumeEOF();
	bool hasDataAvailable() const;
	void readDataChunk(string& collector);
	bool isEOF() const;
private:
	ResponseFilterChain(const ResponseFilterChain& fc);            //
	ResponseFilterChain& operator=(const ResponseFilterChain& fc); // These are not implemeted
	HttpResponseMetadata m_metadata;
	list<AbstractResponseFilter *> m_filters;
	list<AbstractResponseFilter *>::iterator m_waiting_for;
};

#endif

