/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef STATE_H_
#define STATE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef WIN32
#include <windows.h>
#endif

class State
{
private:
	State();
public:
	static State& getInstance();
	bool getFiltering() { return m_filtering; }
	void setFiltering(bool state) { m_filtering = state; }
	bool getScriptFiltering() { return m_script_filtering; }
	void setScriptFiltering(bool state) { m_script_filtering = state; }
	static void lock()
	{
#ifdef WIN32
		WaitForSingleObject(m_mutex, INFINITE);
#endif
	}
	static void unlock()
	{
#ifdef WIN32
		ReleaseMutex(m_mutex);
#endif
	}
private:
#ifdef WIN32
	static HANDLE m_mutex;
#endif
	static State *m_instance;
	bool m_filtering;
	bool m_script_filtering;
};

#endif

